#COMPILE EXE                                              
#DIM ALL                                                                         
#INCLUDE "win32api.inc"
'#INCLUDE "commCtrl.inc"
'#INCLUDE "homeBusAPI.inc"
#INCLUDE "homeBus.inc"
#INCLUDE "columnListClass.inc"
'#INCLUDE "debug.inc"
#RESOURCE "homeBus.pbr"
$verNo = "3.16"

'GLOBAL dbug AS LONG

FUNCTION PBMAIN()AS LONG
   #REGISTER NONE
   LOCAL nStyle, numCols, listX, listY, listW, listH, pageWidth, pageHeight AS LONG
   DIM trans(%MAXTRANS)
   DIM storNames(%MAXNAMES)
   DIM storDescr(%MAXDESCR)
   DIM transType(6)
   DIM reptData(17)
   DIM reptVal(17)
   DIM tabHandle(1 TO 5)
   sPage = "01632"  '5 pages (typeX = 0, 1, 6, 3, 2)
   transType(1) = "Service "
   transType(2) = "Expense "
   transType(3) = "Sold    "
   transType(4) = "Bought  "
   transType(5) = "Personal"
   transType(6) = "Earnings"
   winWidth = 320
   winHeight = 300
   listX = 5
   listY = 10
   listW = winWidth - 22
   listH = winHeight - 82
   '------------------------------------------------------------------------------------------------------
   title = "Home Business Tracker"
   nStyle = %WS_SYSMENU OR %WS_MINIMIZEBOX
   DIALOG NEW 0, title$,,, winWidth, winHeight, nStyle TO hMain
   addMenu
   'addToolbar
   nStyle = %SS_GRAYRECT+%SS_BLACKFRAME
   CONTROL ADD LINE, hMain, %ID_Toolbar, "", 0, 0, winWidth - 4, 22, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hMain, %ID_ServBtn, "Serv", 2, 2, 27, 18, %WS_TABSTOP OR %WS_GROUP
   CONTROL ADD BUTTON, hMain, %ID_EarnBtn, "Earn", 29, 2, 27, 18
   CONTROL ADD BUTTON, hMain, %ID_ProdBtn, "Prod", 56, 2, 27, 18
   CONTROL ADD BUTTON, hMain, %ID_ExpsBtn, "Exps", 83, 2, 27, 18
   CONTROL ADD BUTTON, hMain, %ID_DataBtn, "Data", 119, 2, 27, 18
   CONTROL ADD BUTTON, hMain, %ID_EditBtn, "Edit", 146, 2, 27, 18
   CONTROL ADD BUTTON, hMain, %ID_FilterBtn, "Filter", 173, 2, 27, 18
   CONTROL ADD BUTTON, hMain, %ID_ReptBtn, "Rept", 200, 2, 27, 18
   CONTROL ADD BUTTON, hMain, %ID_QuitBtn, "Quit", 236, 2, 25, 18

   LET oColList1 = CLASS "cColumnList"
   LET oColList2 = CLASS "cColumnList"
   LET oColList3 = CLASS "cColumnList"
   LET oColList4 = CLASS "cColumnList"
   LET oColList5 = CLASS "cColumnList"

   numCols = 5
   DIM wc(1 TO numCols) AS LONG
   DIM tc(1 TO numCols) AS STRING                                                               
   wc(1) = 17: wc(2) = 14: wc(3) = 24: wc(4) = 28: wc(5) = -17  'pct
   tc(1) = CHR$(2) + "Date": tc(2) = "Type": tc(3) = "Descr": tc(4) = "Name": tc(5) = CHR$(1) + "Amount"
   pageWidth = winWidth - 4: pageHeight = winHeight - 70

   'add tabcontrol
   nStyle = %TCS_SINGLELINE OR %TCS_OWNERDRAWFIXED OR %WS_TABSTOP 'OR %TCS_FIXEDWIDTH 'OR %TCS_FOCUSBUTTONDOWN
   CONTROL ADD TAB, hMain, %ID_TabCtrl, "", 1, 25, winWidth - 2, winHeight - 70, nStyle

   'build the first tab page - All Transactions
   TAB INSERT PAGE hMain, %ID_TabCtrl, 1, 0, "All Transactions" CALL TabProc TO hTab
   oColList1.createCtrl(hTab, %ID_All, 2, 0, pageWidth, pageHeight, VARPTR(wc(1)), VARPTR(tc(1)), numCols)
   tabHandle(1) = hTab: 'createHdrs

   'build the second tab page - Services
   TAB INSERT PAGE hMain, %ID_TabCtrl, 2, 0, " Services       " CALL TabProc TO hTab
   oColList2.createCtrl(hTab, %ID_Serv, 2, 0, pageWidth, pageHeight, VARPTR(wc(1)), VARPTR(tc(1)), numCols)
   tabHandle(2) = hTab: 'createHdrs

   'build the third tab page - Earnings
   TAB INSERT PAGE hMain, %ID_TabCtrl, 3, 0, " Earnings       " CALL TabProc TO hTab
   oColList3.createCtrl(hTab, %ID_Earn, 2, 0, pageWidth, pageHeight, VARPTR(wc(1)), VARPTR(tc(1)), numCols)
   tabHandle(3) = hTab: 'createHdrs

   'build the fourth tab page - Products
   TAB INSERT PAGE hMain, %ID_TabCtrl, 4, 0, " Products       " CALL TabProc TO hTab
   oColList4.createCtrl(hTab, %ID_Prod, 2, 0, pageWidth, pageHeight, VARPTR(wc(1)), VARPTR(tc(1)), numCols)
   tabHandle(4) = hTab: 'createHdrs

   'build the fifth tab page - Expenses
   TAB INSERT PAGE hMain, %ID_TabCtrl, 5, 0, " Expenses       " CALL TabProc TO hTab
   oColList5.createCtrl(hTab, %ID_Exps, 2, 0, pageWidth, pageHeight, VARPTR(wc(1)), VARPTR(tc(1)), numCols)
   tabHandle(5) = hTab: 'createHdrs

   DIALOG SHOW MODAL hMain CALL mainProc
END FUNCTION

CALLBACK FUNCTION mainProc()
   LOCAL hIcon, hInst AS LONG
   LOCAL n, result, hIniFile, flags AS LONG
   LOCAL tab0, tab1, tab2, tab3, tab4 AS LONG PTR
   LOCAL f, s, ti, folder, progFolder, filter, TXT AS STRING
   STATIC lastTab AS LONG
   STATIC helpFile AS ASCIIZ * %MAX_PATH
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         '------------------------------------------------
         hTab = tabHandle(1)
         hInst = GetModuleHandle(BYVAL %NULL)
         hIcon = LoadImage(hInst, "myBus", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND CBHNDL, %WM_SETICON, %ICON_BIG, hIcon
         
         'first, we must define the Windows data folder
         progFolder = specialFolder(%CSIDL_PROGRAM_FILES) + "\cgdSoftware\homebus\"
         IF LCASE$(EXE.PATH$) = LCASE$(progFolder) THEN 'data in Windows special folder
            dataFolder = specialFolder(%CSIDL_COMMON_APPDATA) 
            dataFolder = dataFolder + "\cgdSoftware\homebus\"      
         ELSE 'data in path of running program 
            dataFolder = EXE.PATH$
         END IF
         IF ISFOLDER(dataFolder) = 0 THEN MKDIR dataFolder
         
'         'dataFolder = specialFolder(%CSIDL_COMMON_DOCUMENTS)
'         dataFolder = specialFolder(%CSIDL_COMMON_APPDATA)
'         IF LEN(dataFolder) = 0 THEN dataFolder = "C:\My Documents\"
'         dataFolder = dataFolder + "\cgdSoftware\HomeBus\"
'         IF ISFOLDER(dataFolder) = 0 THEN createFolder dataFolder 

         IF ISFILE(dataFolder + "homeBus.ini") THEN
            hIniFile = FREEFILE
            OPEN dataFolder + "homeBus.ini" FOR INPUT AS #hIniFile
            LINE INPUT #hIniFile, thisFile
            LINE INPUT #hIniFile, TXT: stateTax = VAL(TXT)
            LINE INPUT #hIniFile, TXT: countyTax = VAL(TXT)
            LINE INPUT #hIniFile, TXT: localTax = VAL(TXT)
            LINE INPUT #hIniFile, TXT: districtTax = VAL(TXT)
            CLOSE #hIniFile
            taxRate = stateTax + countyTax + localTax + districtTax
         END IF
         IF ISFILE(thisFile) THEN openThisFile
         endDate = 65535
         CONTROL ADD STATUSBAR, hMain, 999, "", 0, 0, 0, 0
         STATUSBAR SET PARTS hMain, 999, 250, 999
         showStatus 0: 'showStatus 1                                          
         helpFile = dataFolder + "\HomeBus.chm"
         nTab = 1: oColList = oColList1: idList = %ID_All
         listTransX
      CASE %WM_DRAWITEM 'draw tab item text in different color on select
         IF CB.WPARAM = %ID_TabCtrl THEN colorTab CBHNDL, CBWPARAM, CBLPARAM
      CASE %WM_NOTIFY
         IF CB.WPARAM = %ID_TabCtrl THEN 'select tab
            TAB GET SELECT CBHNDL, %ID_TabCtrl TO nTab
            CONTROL SEND hTab, %ID_List, %TCM_SETCURFOCUS, nTab, 0
            SELECT CASE ntab
               CASE 1: oColList = oColList1: idList = %ID_All
               CASE 2: oColList = oColList2: idList = %ID_Serv
               CASE 3: oColList = oColList3: idList = %ID_Earn
               CASE 4: oColList = oColList4: idList = %ID_Prod
               CASE 5: oColList = oColList5: idList = %ID_Exps
            END SELECT
            hTab = tabHandle(nTab): typeX = VAL(MID$(sPage, nTab, 1))
            highLite = 0: IF nTab <> lastTab THEN listTransX
            lastTab = nTab
         END IF
      CASE %WM_COMMAND
      IF CBCTLMSG = %BN_CLICKED THEN
         IF CBCTL = %IDM_FileOpen THEN
            ti = "Open File": folder = dataFolder
            flags = %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
            filter = CHR$("Business", 0, "*.bus", 0, "All Files", 0, "*.*", 0)
            DISPLAY OPENFILE CBHNDL,,, ti, folder, filter, "", "bus", flags TO f
            IF LEN(f) THEN
               IF fileChanged THEN
                 s = "Current file has changed..." + $CRLF + "Save it before opening the new file?"
                 n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
                 IF n = %IDYES THEN saveThisFile
               END IF
               thisFile = f: openThisFile
               listTransX: showStatus 0: showStatus 1
            END IF
         ELSEIF CBCTL = %IDM_FileSave THEN
            s = "Save this file now?"
            n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
            IF n = %IDYES THEN saveThisFile
         ELSEIF CBCTL = %IDM_FileSaveAs THEN
            saveAsFile: showStatus
         ELSEIF CBCTL = %IDM_FilePrint THEN
            printThisFile
         ELSEIF CBCTL = %IDM_FileArchive THEN
            archiveFile
         ELSEIF CBCTL = %IDM_FileExit THEN
            DIALOG SEND CBHNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
         ELSEIF CBCTL >= %IDM_AddService AND CBCTL <= %IDM_AddExpense THEN 'addMenus
            DIALOG SEND CBHNDL, %WM_COMMAND, CBCTL - %IDM_AddService + %ID_ServBtn, 0
         ELSEIF CBCTL = %IDM_EditChange THEN
            DIALOG SEND CBHNDL, %WM_COMMAND, %ID_EditBtn, 0
         ELSEIF CBCTL = %IDM_EditDelete THEN
            TXT = "Delete this record now?"
            result = MSGBOX(TXT, %MB_YESNO + %MB_ICONERROR, "Update Descriptions")
            IF result = %IDYES THEN
               addDescr = 0: addNameX = 0: delTransX
               showStatus 1: listTransX
            END IF
         ELSEIF CBCTL = %IDM_EditNames THEN
            editList(0)
         ELSEIF CBCTL = %IDM_EditDescr THEN
            editList(1)
         ELSEIF CBCTL = %IDM_EditTax THEN
            editTaxesForm
         ELSEIF CBCTL = %IDM_ViewFilter THEN
            DIALOG SEND CBHNDL, %WM_COMMAND, %ID_FilterBtn, 0
         ELSEIF CBCTL = %IDM_ViewForm THEN
            DIALOG SEND CBHNDL, %WM_COMMAND, %ID_DataBtn, 0
         ELSEIF CBCTL = %IDM_ViewReport THEN
            DIALOG SEND CBHNDL, %WM_COMMAND, %ID_ReptBtn, 0
         ELSEIF CBCTL = %IDM_HelpContent THEN
            HtmlHelp CBHNDL, helpFile, 0, 0
         ELSEIF CBCTL = %IDM_HelpAbout THEN
            showAbout
         ELSEIF CBCTL >= 1001 AND CBCTL <= 1006 THEN 'add service, expense, product, earning
            typeX = CBCTL - 1000: addTransX(0)
         ELSEIF CBCTL = %ID_DataBtn THEN 'view data
            highLite = oColList.hilite
            n = recordNo(oColList.getRecordNo(highLite))
            typeX = trans(n).typeX
            showPrev = 1: index = n: showTransXData()
            xPos = 0: yPos = 0
         ELSEIF CBCTL = %ID_EditBtn THEN 'edit data
            highLite = oColList.hilite
            n = recordNo(oColList.getRecordNo(highLite))
            typeX = trans(n).typeX
            addTransX(n): showStatus 1
         ELSEIF CBCTL = %ID_FilterBtn THEN 'filter button
            filterTransX
         ELSEIF CBCTL = %ID_ReptBtn THEN 'report button
            taxReport
         ELSEIF CBCTL = %ID_QuitBtn THEN 'quit button
            DIALOG SEND CBHNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
         END IF
         FOR n = %ID_Toolbar TO %ID_FilterBtn 'clear visible focus of buttons pressed
            CONTROL SEND CBHNDL, n, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
         NEXT n
         CONTROL SET FOCUS hTab, %ID_List
      END IF
   CASE %WM_SYSCOMMAND
      IF CBCTL = %SC_CLOSE THEN
         IF fileChanged THEN
              s = "This file has changed... save it before quiting?"
              n = MSGBOX(s, %MB_YESNOCANCEL + %MB_ICONQUESTION, "Quit Program")
              IF n = %IDCANCEL THEN FUNCTION = 1: EXIT FUNCTION
              IF n = %IDYES THEN saveThisFile
         ELSE
            f = "Quit program now?"
            result = MSGBOX(f, %MB_OKCANCEL OR %MB_ICONQUESTION, "Quit Program")
            IF result = %IDCANCEL THEN FUNCTION = 1: EXIT FUNCTION
         END IF
         IF iniFileChanged THEN
            hIniFile=FREEFILE
            f = "#.######"
            OPEN dataFolder + "homeBus.ini" FOR OUTPUT AS #hIniFile
            PRINT #hIniFile, thisFile
            PRINT #hIniFile, FORMAT$(stateTax, f)
            PRINT #hIniFile, FORMAT$(countyTax, f)
            PRINT #hIniFile, FORMAT$(localTax, f)
            PRINT #hIniFile, FORMAT$(districtTax, f)
            CLOSE #hIniFile
         END IF
      END IF
   END SELECT
END FUNCTION

CALLBACK FUNCTION TabProc()
   LOCAL k, n, nCol AS LONG
   SELECT CASE CB.MSG
   CASE %WM_COMMAND
      IF CB.CTL = idList AND CB.CTLMSG = %LBN_SELCHANGE THEN
         showStatus 1
      END IF
   END SELECT
END FUNCTION

SUB colorTab(hDlg AS LONG, wParm AS LONG, lParm AS LONG)
   LOCAL nColor, hBrush AS LONG
   LOCAL lDISPtr AS DRAWITEMSTRUCT PTR
   LOCAL ti AS TC_ITEM, zCap AS ASCIIZ * 50

   lDisPtr = lparm
   nColor = RGB(220, 230&, 240&)
   hBrush = CreateSolidBrush(nColor)
   SelectObject @lDisptr.hDc, hBrush

   @lDisptr.rcItem.nTop = @lDisptr.rcItem.nTop + 3
   IF @lDisPtr.ItemState = %ODS_SELECTED THEN
      SetTextColor @lDisPtr.hDc, %BLUE
      SetBkColor @lDisPtr.hDc, nColor
      FillRect @lDisptr.hDc, @lDisptr.rcItem, hBrush
   ELSE
      SetTextColor @lDisPtr.hDc, %BLACK
      SetBkColor @lDisPtr.hDc, GetSysColor(%COLOR_3DFACE)
      FillRect @lDisptr.hDc, @lDisptr.rcItem, GetSysColorBrush(%COLOR_3DFACE)
   END IF

   ti.mask = %TCIF_TEXT
   ti.pszText = VARPTR(zCap)
   ti.cchTextMax = SIZEOF(zCap)
   CALL TabCtrl_GetItem(GetDlgItem(hDlg, wParm), @lDisptr.itemID, ti)
   DrawText @lDisptr.hDc, zCap, LEN(zCap), @lDisptr.rcItem, %DT_SINGLELINE OR %DT_CENTER
   DeleteObject hBrush
END SUB

SUB addMenu()
   LOCAL hMenu, hFileMenu, hEditMenu, hViewMenu AS LONG
   LOCAL hEditAddMenu, hHelpMenu AS LONG
   MENU NEW BAR TO hMenu
   'declare menu popUps
   MENU NEW POPUP TO hFileMenu
   MENU NEW POPUP TO hEditMenu
   MENU NEW POPUP TO hViewMenu
   MENU NEW POPUP TO hHelpMenu
   MENU NEW POPUP TO hEditAddMenu
   'fill out top menus
   MENU ADD POPUP, hMenu, "&File", hFileMenu,%MF_ENABLED
   MENU ADD POPUP, hMenu, "&Edit", hEditMenu,%MF_ENABLED
   MENU ADD POPUP, hMenu, "&View", hViewMenu,%MF_ENABLED
   MENU ADD POPUP, hMenu, "&Help", hHelpMenu,%MF_ENABLED
   'fill out drop down menus
   MENU ADD STRING, hFileMenu, "&Open", %IDM_FileOpen,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Save", %IDM_FileSave,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save&As", %IDM_FileSaveAs,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "&Archive", %IDM_FileArchive,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Print", %IDM_FilePrint,%MF_ENABLED
   MENU ADD STRING, hFileMenu, "E&xit", %IDM_FileExit,%MF_ENABLED
   MENU ADD POPUP, hEditMenu, "Add record", hEditAddMenu, %MF_ENABLED
   MENU ADD STRING, hEditAddMenu, "Service", %IDM_AddService, %MF_ENABLED
   MENU ADD STRING, hEditAddMenu, "Earning", %IDM_AddEarning, %MF_ENABLED
   MENU ADD STRING, hEditAddMenu, "Product", %IDM_AddProduct, %MF_ENABLED
   MENU ADD STRING, hEditAddMenu, "Expense", %IDM_AddExpense, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Change record", %IDM_EditChange, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Delete record", %IDM_EditDelete, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Names list", %IDM_EditNames, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Descr list", %IDM_EditDescr, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&State sales tax", %IDM_EditTax, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Filtered", %IDM_ViewFilter, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Form data", %IDM_ViewForm, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Tax Report", %IDM_ViewReport, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "&Contents", %IDM_HelpContent, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "&About", %IDM_HelpAbout, %MF_ENABLED
   'put menu system on window
   MENU ATTACH hMenu, hMain
END SUB

SUB showStatus(OPT BYVAL panelNo AS LONG)
   LOCAL n AS LONG, s AS STRING, thisFileDir AS STRING
   IF panelNo THEN
      highLite = oColList.hiLite
      s = STR$(highLite)+" :"+STR$(numShown)
   ELSE
      s = thisFile
      n = INSTR(-1, thisFile, "\")
      thisFileDir = LEFT$(thisFile, n)
      IF thisFileDir = dataFolder THEN s = MID$(thisFile, n + 1)
   END IF
   STATUSBAR SET TEXT hMain, 999, panelNo + 1, 0, s
END SUB

FUNCTION MakeFont(fontName AS STRING, fontSize AS LONG, OPT BYVAL fontAttr AS STRING) AS LONG
   'specify descr = b for bold, u for underline, i for italic
   LOCAL hDC, CyPixels, charHt, wt, nBold, underline, italic AS LONG
   IF LEN(fontAttr) THEN
      nBold = INSTR(fontAttr, "b") + 300
      underline = INSTR(fontAttr,"u")
      italic = INSTR(fontAttr,"i")
   END IF
   hDC = GetDC(%HWND_DESKTOP)
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (fontSize * CyPixels) \ 72
   wt = %FW_NORMAL + nBold
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY fontName)
END FUNCTION

SUB listTransX
   'the purpose of this routine is to determine the records
   'to list as specified by the filter and the tab page
   'the records, so determined, are kept in the array recordNo()
   '-------------------------------------------------------------
   LOCAL i, ok, n1, n2, n3 AS LONG, d AS WORD
   TAB GET SELECT hMain, %ID_TabCtrl TO nTab
   IF nTab = 1 THEN typeX = 0
   numShown = 0
   FOR i = 1 TO numTrans
      ok = 1
      d = trans(i).date: n1 = trans(i).typeX
      n2 = trans(i).descr: n3 = trans(i).names:
      IF d < startDate OR d > endDate THEN ok = 0
      IF typeX >= 3 AND typeX <= 5 THEN
         IF n1 < 3 OR n1 = 6 THEN ok = 0
      ELSEIF typeX THEN
         IF n1 <> typeX THEN ok = 0
      END IF
      IF descr AND MID$(storDescr(n2), 2) <> MID$(storDescr(descr), 2) THEN ok = 0
      IF names AND MID$(storNames(n3), 2) <> MID$(storNames(names), 2) THEN ok = 0
      IF ok THEN
         INCR numShown: REDIM PRESERVE recordNo(1 TO numShown): recordNo(numShown) = i
      END IF
   NEXT i
   showTheList
END SUB

SUB showTheList()
   'this routine displays the list given only recordNo() and numShown
   '---------------------------------------------------------------
   LOCAL i, j, k, n1, n2, n3, total AS LONG
   LOCAL s, sType, sDescr, sName, sTotal AS STRING
   LOCAL d, tax AS WORD
   k = numShown                                                    
   'oColList.setListID = idList
   oColList.setNumItems = 0
   FOR j = 1 TO numShown
      i = recordNo(j)
      IF i = index THEN k = j: index = 0
      d = trans(i).date
      n1 = trans(i).typeX
      sType = transType(n1)
      n2 = trans(i).descr: sDescr = MID$(storDescr(n2),2)
      n3 = trans(i).names: sName = MID$(storNames(n3),2)
      IF trans(i).taxOpt <> 1 THEN tax = trans(i).taxAmt ELSE tax = 0
      total = trans(i).amount + trans(i).handling + trans(i).shipping + tax
      sTotal = showVal(total)
      s = expandDate(d) + $TAB + sType + $TAB + sDescr + $TAB + sName + $TAB + sTotal
      oColList.addItem s
   NEXT j
   oColList.showList
   oColList.setHiLite k, 1: highLite = k
   CONTROL SET FOCUS hTab, idList
   showStatus 1
END SUB

SUB showTransXData()
   LOCAL ht AS LONG
   title = transType(typeX): ht = 100
   IF typeX >= 3 AND typeX < 6 THEN title = "product": ht = 185
   title = title + " transaction"
   DIALOG NEW hMain, title$, xPos, yPos, 250, ht, %WS_SYSMENU TO hAdd
   CONTROL ADD TEXTBOX, hAdd, %ID_DateTxt, "", 50, 5, 25, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hAdd, %ID_YearTxt, "", 121, 5, 25, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hAdd, %ID_DescrCmbo, "", 50, 25, 80, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hAdd, %ID_NamesCmbo, "", 50, 45, 90, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hAdd, %ID_Amount, "", 50, 65, 40, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hAdd, -1, "Date:", 3, 5, 45, 12, %SS_RIGHT
   CONTROL ADD LABEL, hAdd, -1, "Year:", 100, 5, 18, 12, %SS_RIGHT
   CONTROL ADD LABEL, hAdd, -1, "Descr:", 3, 25, 45, 12, %SS_RIGHT
   CONTROL ADD LABEL, hAdd, -1, "Name:", 3, 45, 45, 12, %SS_RIGHT
   CONTROL ADD LABEL, hAdd, -1, "Amount:", 3, 65, 45, 12, %SS_RIGHT
   IF typeX >= 3 AND typeX < 6 THEN 'extra fields for product
      CONTROL ADD OPTION, hAdd, %ID_SoldOpt, "&Sold", 110, 65, 35, 12, %WS_DISABLED
      CONTROL ADD OPTION, hAdd, %ID_BoughtOpt, "&Bought", 148, 65, 40, 12, %WS_DISABLED
      CONTROL ADD OPTION, hAdd, %ID_PersonalOpt, "&Personal", 190, 65, 40, 12, %WS_DISABLED
      CONTROL SET CHECK hAdd, %ID_SoldOpt, 0
      CONTROL SET CHECK hAdd, %ID_BoughtOpt, 0
      CONTROL SET CHECK hAdd, %ID_PersonalOpt, 0
      CONTROL ADD TEXTBOX, hAdd, %ID_Handling, "", 50, 85, 40, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
      CONTROL ADD TEXTBOX, hAdd, %ID_Shipping, "", 50, 105, 40, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
      CONTROL ADD TEXTBOX, hAdd, %ID_TaxAmt, "", 50, 125, 40, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
      CONTROL ADD TEXTBOX, hAdd, %ID_Total, "", 50, 145, 40, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
      CONTROL ADD LABEL, hAdd, -1, "Handling:", 3, 85, 45, 12, %SS_RIGHT
      CONTROL ADD LABEL, hAdd, -1, "Shipping:", 3, 105, 45, 12, %SS_RIGHT
      CONTROL ADD LABEL, hAdd, -1, "Sales Tax:", 3, 125, 45, 12, %SS_RIGHT
      CONTROL ADD LABEL, hAdd, -1, "Total:", 3, 145, 45, 12, %SS_RIGHT
   END IF
   CONTROL ADD BUTTON, hAdd, %ID_NextBtn, "&Next", 200, 5, 40, 20
   CONTROL ADD BUTTON, hAdd, %ID_PrevBtn, "&Prev", 200, 30, 40, 20
   'DIALOG SET USER hAdd, 1, highLite
   DIALOG SHOW MODAL hAdd CALL showTransXProc
END SUB

CALLBACK FUNCTION showTransXProc()
   LOCAL n AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         fillTransXForm
      CASE %WM_COMMAND
         IF CBCTL = %ID_NextBtn THEN
            IF highLite < numShown THEN
               DIALOG GET LOC CBHNDL TO xPos, yPos
               DIALOG END hAdd
               showPrev = 0: INCR highLite
               n = recordNo(oColList.getRecordNo(highLite))
               typeX = trans(n).typeX: oColList.setHiLite highLite
               CONTROL SEND hTab, %ID_List, %LB_SETCURSEL, highLite-1, 0
               index = n: showTransXData()
            END IF
         ELSEIF CBCTL = %ID_PrevBtn THEN
            IF highLite > 1 THEN
               DIALOG GET LOC CBHNDL TO xPos, yPos
               DIALOG END hAdd
               showPrev = 1: DECR highLite
               n = recordNo(oColList.getRecordNo(highLite))
               typeX = trans(n).typeX: oColList.setHiLite highLite
               CONTROL SEND hTab, %ID_List, %LB_SETCURSEL, highLite - 1, 0
               index = n: showTransXData
            END IF
         END IF
   END SELECT
END FUNCTION

SUB addTransX(recdNo AS LONG)
   LOCAL ht, nStyle AS LONG
   LOCAL TXT AS STRING
   title = LCASE$(transType(typeX)): ht = 105
   IF typeX >= 3 AND typeX < 6 THEN title = "product": ht = 220 '185
   IF recdNo THEN TXT = "Change " ELSE TXT = "Add new "
   title = TXT + title + " transaction"
   'build hAdd dialog box ---------------------------------------------------
   DIALOG NEW hMain, title, , , 250, ht, %WS_SYSMENU TO hAdd
   CONTROL ADD TEXTBOX, hAdd, %ID_DateTxt, "", 50, 5, 25, 12
   CONTROL ADD TEXTBOX, hAdd, %ID_YearTxt, year, 121, 5, 25, 12
   nStyle = %WS_VSCROLL OR %CBS_DISABLENOSCROLL OR %WS_TABSTOP OR %CBS_DROPDOWN OR %CBS_SORT
   CONTROL ADD COMBOBOX, hAdd, %ID_DescrCmbo, , 50, 25, 90, 100, nStyle
   CONTROL ADD COMBOBOX, hAdd, %ID_NamesCmbo, , 50, 45, 90, 100, nStyle
   CONTROL ADD TEXTBOX, hAdd, %ID_Amount, "", 50, 65, 40, 12
   CONTROL ADD LABEL, hAdd, -1, "Date:", 3, 5, 45, 12, %SS_RIGHT
   CONTROL ADD LABEL, hAdd, -1, "Year:", 100, 5, 18, 12, %SS_RIGHT
   CONTROL ADD LABEL, hAdd, -1, "Descr:", 3, 25, 45, 12, %SS_RIGHT
   CONTROL ADD LABEL, hAdd, -1, "Name:", 3, 45, 45, 12, %SS_RIGHT

   CONTROL ADD LABEL, hAdd, %ID_LabelAmt, "Orig Cost:", 3, 65, 45, 12, %SS_RIGHT
   IF typeX >= 3 AND typeX < 6 THEN 'extra fields for product
      CONTROL ADD LABEL, hAdd, %ID_LabelAmt, "Orig Cost:", 3, 65, 45, 12, %SS_RIGHT
      CONTROL ADD OPTION, hAdd, %ID_SoldOpt, "&Sold", 110, 65, 35, 12, %WS_TABSTOP, 0
      CONTROL ADD OPTION, hAdd, %ID_BoughtOpt, "&Bought", 148, 65, 40, 12, 0, 0
      CONTROL ADD OPTION, hAdd, %ID_PersonalOpt, "&Personal", 190, 65, 40, 12, 0, 0
      CONTROL ADD LABEL, hAdd, -1, "Handling:", 3, 85, 45, 12, %SS_RIGHT OR %WS_GROUP
      CONTROL ADD LABEL, hAdd, -1, "Shipping:", 3, 105, 45, 12, %SS_RIGHT
      CONTROL ADD LABEL, hAdd, -1, "Sales Tax:", 3, 125, 45, 12, %SS_RIGHT
      CONTROL ADD LABEL, hAdd, -1, "%", 95, 125, 12, 12, %SS_RIGHT
      CONTROL ADD LABEL, hAdd, -1, "Total:", 3, 145, 45, 12, %SS_RIGHT
      CONTROL ADD TEXTBOX, hAdd, %ID_Handling, "", 50, 85, 40, 12
      CONTROL ADD TEXTBOX, hAdd, %ID_Shipping, "", 50, 105, 40, 12
      CONTROL ADD TEXTBOX, hAdd, %ID_TaxAmt, "", 50, 125, 40, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
      CONTROL ADD TEXTBOX, hAdd, %ID_TaxRate, "", 110, 125, 30, 12
      CONTROL ADD TEXTBOX, hAdd, %ID_Total, "", 50, 145, 40, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
      CONTROL ADD OPTION, hAdd, %ID_AddTaxOpt, "Tax to be added", 160, 108, 80, 12, %WS_TABSTOP
      CONTROL ADD OPTION, hAdd, %ID_InclTaxOpt, "&Tax already included", 160, 120, 80, 12
      CONTROL ADD OPTION, hAdd, %ID_SpecifyOpt, "&Specify tax", 160, 132, 80, 12
      CONTROL ADD OPTION, hAdd, %ID_ResaleOpt, "Resale - no tax", 160, 144, 80, 12
      CONTROL SET CHECK hAdd, %ID_AddTaxOpt, 0
      CONTROL SET CHECK hAdd, %ID_InclTaxOpt, 0
      CONTROL ADD BUTTON, hAdd, %ID_Clear, "C&lear", 10, 170, 50, 22, %WS_TABSTOP OR %WS_GROUP
      CONTROL ADD BUTTON, hAdd, %ID_OK, "&OK", 130, 170, 50, 22, %WS_TABSTOP OR %WS_GROUP
      CONTROL ADD BUTTON, hAdd, %IDCANCEL, "Cancel", 182, 170, 50, 22, %WS_TABSTOP OR %WS_GROUP
   ELSE
      CONTROL ADD LABEL, hAdd, %ID_LabelAmt, "Amount:", 3, 65, 45, 12, %SS_RIGHT
      CONTROL ADD BUTTON, hAdd, %ID_OK, "&OK", 200, 5, 40, 30
   END IF
   index = recdNo
   DIALOG SHOW MODAL hAdd CALL addTransXProc
END SUB

CALLBACK FUNCTION addTransXProc()
   LOCAL s, ss, TXT AS STRING
   LOCAL byteX AS BYTE
   LOCAL result, i, j, k AS LONG
   LOCAL x, tax AS DOUBLE
   LOCAL transX AS transAction
   STATIC shipping, handling, rate, lastOpt AS DOUBLE
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         fillLists(CBHNDL): rate = taxRate
         IF index THEN 'editing transaction... will delete and insert
            fillTransXForm
         ELSE 'new transaction
            CONTROL SET OPTION CBHNDL, %ID_SoldOpt, %ID_SoldOpt, %ID_PersonalOpt
            CONTROL SET OPTION CBHNDL, %ID_AddTaxOpt, %ID_AddTaxOpt, %ID_ResaleOpt
            CONTROL SET FOCUS CBHNDL, %ID_DateTxt
         END IF
         CONTROL SET TEXT CBHNDL, %ID_TaxRate, FORMAT$(taxRate * 100, "0.000")
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %ID_DescrCmbo, %ID_NamesCmbo
               IF CB.CTLMSG = %CBN_EDITCHANGE THEN
                  CONTROL GET TEXT CB.HNDL, CB.CTL TO s
                  COMBOBOX FIND CB.HNDL, CB.CTL, 1, s TO k
                  IF k THEN
                     COMBOBOX GET TEXT CB.HNDL, CB.CTL, k TO ss
                     CONTROL SET TEXT CB.HNDL, CB.CTL, ss
                     CONTROL SEND CB.HNDL, CB.CTL, %CB_SETEDITSEL, 0, MAKDWD(LEN(s), -1)
                  END IF
               END IF
            CASE %ID_SoldOpt TO %ID_PersonalOpt
               IF CB.CTL = %ID_SoldOpt THEN k = %SW_SHOW ELSE k = %SW_HIDE
               CONTROL SHOW STATE CB.HNDL, %ID_ResaleOpt, k
            CASE %ID_AddTaxOpt TO %ID_ResaleOpt
               CONTROL GET TEXT CBHNDL, %ID_Amount TO s: x = VAL(s)
               IF CBCTL = %ID_SpecifyOpt AND lastOpt <> 2 THEN
                  CONTROL KILL CBHNDL, %ID_TaxAmt
                  CONTROL ADD TEXTBOX, hAdd, %ID_TaxAmt, "", 50, 125, 40, 12
                  CONTROL SET FOCUS CBHNDL, %ID_TaxAmt
               ELSEIF lastOpt = 2 THEN
                  CONTROL KILL CBHNDL, %ID_TaxAmt
                  CONTROL ADD TEXTBOX, hAdd, %ID_TaxAmt, "", 50, 125, 40, 12, %ES_READONLY, %WS_EX_CLIENTEDGE
               END IF
               ss = "Orig Cost:"
               IF CBCTL = %ID_AddTaxOpt THEN
                  tax = x * rate: lastOpt = 0
               ELSEIF CBCTL = %ID_InclTaxOpt THEN
                  tax = x * rate /(1 + rate): ss = "Amt Paid:": lastOpt = 1
               ELSEIF CBCTL = %ID_SpecifyOpt THEN
                  tax = 0: lastOpt = 2
               ELSEIF CBCTL = %ID_ResaleOpt THEN
                  tax = 0: lastOpt = 3
               END IF
               CONTROL SET TEXT CBHNDL, %ID_LabelAmt, ss
               CONTROL SET TEXT CBHNDL, %ID_TaxAmt, ""
               IF tax THEN CONTROL SET TEXT CBHNDL, %ID_TaxAmt, FORMAT$(tax, $fmt)
               calcTotal
            CASE %ID_Amount, %ID_TaxRate
               IF CBCTLMSG = %EN_CHANGE AND typeX >= 3 AND typeX <= 5 THEN
                  IF CBCTL = %ID_TaxRate THEN
                     CONTROL GET TEXT CBHNDL, CBCTL TO s: rate = VAL(s)/100
                     IF rate = 0 THEN CONTROL SET TEXT CBHNDL, CBCTL, STR$(100 * taxRate)
                  END IF
                  k = getOption(CBHNDL, %ID_AddTaxOpt, %ID_ResaleOpt)
                  DIALOG SEND CBHNDL, %WM_COMMAND, %ID_AddTaxOpt + k - 1, 0
               END IF
            CASE %ID_Amount TO %ID_TaxAmt
               IF CBCTLMSG = %EN_CHANGE AND typeX >= 3 AND typeX <= 5 THEN calcTotal
            CASE %ID_Clear
               FOR i = 1 TO 10
                  CONTROL SET TEXT CBHNDL, 2000 + i, ""
               NEXT i
               CONTROL SET CHECK CBHNDL, %ID_SoldOpt, 1
               CONTROL SET CHECK CBHNDL, %ID_BoughtOpt, 0
               CONTROL SET CHECK CBHNDL, %ID_PersonalOpt, 0
               CONTROL SET CHECK CBHNDL, %ID_AddTaxOpt, 0
               CONTROL SET CHECK CBHNDL, %ID_InclTaxOpt, 0
               CONTROL SET TEXT CBHNDL, %ID_TaxRate, FORMAT$(taxRate * 100, "0.000")
               CONTROL SEND hAdd, %ID_TaxAmt, %EM_SETREADONLY, 0, 0
            CASE %ID_Ok  'process this record
               CONTROL GET TEXT hAdd,%ID_DateTxt TO TXT
               CONTROL GET TEXT hAdd,%ID_YearTxt TO year
               TXT = TXT + "-" + year: TXT = legalDate(TXT)
               IF LEN(TXT)=0 THEN MSGBOX "Illegal date", %MB_ICONERROR: EXIT FUNCTION
               transX.date = compressDate(TXT)
               transX.typeX = typeX: byteX = typeX
               IF typeX >=3 AND typeX <= 5 THEN
                  byteX = 3
                  transX.typeX = getOption(CBHNDL, %ID_SoldOpt, %ID_PersonalOpt) + 2
               END IF

               CONTROL GET TEXT hAdd, %ID_DescrCmbo TO TXT: TXT = TRIM$(TXT)
               IF LEN(TXT) THEN
                  COMBOBOX FIND EXACT CB.HNDL, %ID_DescrCmbo, 1, TXT TO k
                  IF k THEN
                     COMBOBOX GET USER CB.HNDL, %ID_DescrCmbo, k TO result
                     transX.descr = result
                  ELSE
                     j = MSGBOX("Ok to add this description?", %MB_ICONQUESTION OR %MB_YESNO, TXT)
                     IF j = %IDYES THEN
                        INCR numDescr: storDescr(numDescr) = CHR$(byteX) + TXT
                        transX.descr = numDescr
                     END IF
                  END IF
               END IF

               CONTROL GET TEXT hAdd, %ID_NamesCmbo TO TXT: TXT = TRIM$(TXT)
               IF LEN(TXT) THEN
                  COMBOBOX FIND EXACT CB.HNDL, %ID_NamesCmbo, 1, TXT TO k
                  IF k THEN
                     COMBOBOX GET USER CB.HNDL, %ID_NamesCmbo, k TO result
                     transX.names = result
                  ELSE
                     j = MSGBOX("Ok to add this name?", %MB_ICONQUESTION OR %MB_YESNO, TXT)
                     IF j = %IDYES THEN
                        INCR numNames: storNames(numNames) = CHR$(byteX) + TXT
                        transX.names = numNames
                     END IF
                  END IF
               END IF

               transX.taxOpt = getOption(hAdd, %ID_AddTaxOpt, %ID_ResaleOpt) - 1
               CONTROL GET TEXT hAdd, %ID_TaxRate TO TXT
               transX.taxRate = VAL(TXT)
               CONTROL GET TEXT hAdd, %ID_Amount TO TXT
               transX.amount = storVal(TXT)
               CONTROL GET TEXT hAdd, %ID_Handling TO TXT
               transX.handling = storVal(TXT)
               CONTROL GET TEXT hAdd, %ID_Shipping TO TXT
               transX.shipping = storVal(TXT)
               CONTROL GET TEXT hAdd, %ID_TaxAmt TO TXT
               transX.taxAmt = storVal(TXT)
               IF transX.descr OR transX.names THEN
                  IF transX.amount = 0 THEN
                     MSGBOX "No amount specified", %MB_ICONWARNING
                     CONTROL SET FOCUS hAdd, %ID_Amount
                     EXIT FUNCTION
                  ELSE 'ok to process
                     IF index THEN 'editing transaction
                        addDescr = transX.descr
                        addNameX = transX.names
                        delTransX
                     END IF
                     insertTrans transX
                     fileChanged = 1
                  END IF
               ELSE
                  MSGBOX "No description or name entered", %MB_ICONWARNING
                  EXIT FUNCTION
               END IF
               DIALOG END hAdd
            CASE %IDCANCEL
               DIALOG END CBHNDL
            END SELECT
   END SELECT
END FUNCTION

SUB fillTransXForm()
   LOCAL n, k, z, taxAmt AS LONG
   LOCAL TXT AS STRING, v AS BYTE
'   highLite = oColList.hilite
'   n = recordNo(highLite)
   n = index
   TXT = expandDate(trans(n).date)
   CONTROL SET TEXT hAdd, %ID_DateTxt, LEFT$(TXT, 5)
   CONTROL SET TEXT hAdd, %ID_YearTxt, RIGHT$(TXT, 4)
   IF typeX = %expense THEN
      TXT = LCASE$(MID$(storDescr(trans(n).descr),2))
      IF TXT = "mileage" THEN CONTROL ADD LABEL, hAdd, -1, " Miles:",3,65,45,12,%SS_RIGHT
   END IF
   CONTROL SET TEXT hAdd, %ID_DescrCmbo, MID$(storDescr(trans(n).descr),2)
   CONTROL SET TEXT hAdd, %ID_NamesCmbo, MID$(storNames(trans(n).names),2)
   CONTROL SET TEXT hAdd, %ID_Amount, showVal(trans(n).amount)

   IF typeX >= 3 AND typeX < 6 THEN 'extra fields for product
      v = trans(n).typeX - 2
      IF typeX = 3 THEN k = %SW_SHOW ELSE k = %SW_HIDE
      CONTROL SHOW STATE hAdd, %ID_ResaleOpt, k

      CONTROL SET CHECK hAdd, %ID_SoldOpt + v - 1, 1
      CONTROL SET TEXT hAdd, %ID_Handling, showVal(trans(n).handling)
      CONTROL SET TEXT hAdd, %ID_Shipping, showVal(trans(n).shipping)
      CONTROL SET OPTION hAdd, %ID_AddTaxOpt + trans(n).taxOpt, %ID_AddTaxOpt, %ID_ResaleOpt
      CONTROL SET TEXT hAdd, %ID_TaxAmt, showVal(trans(n).taxAmt)
      IF trans(n).taxOpt = 1 THEN
         taxAmt = 0
         CONTROL SET TEXT hAdd, %ID_LabelAmt, "Amt Paid:"
      ELSE
         taxAmt = trans(n).taxAmt
         CONTROL SET TEXT hAdd, %ID_LabelAmt, "Orig Cost:"
         IF trans(n).taxOpt = 2 THEN 'need to edit tax amt
            CONTROL KILL hAdd, %ID_TaxAmt
            CONTROL ADD TEXTBOX, hAdd, %ID_TaxAmt, "", 50, 125, 40, 12
         END IF
      END IF
      z = trans(n).amount + trans(n).handling + trans(n).shipping + taxAmt
      CONTROL SET TEXT hAdd, %ID_Total, showVal(z)
   END IF
   IF showPrev = 1 THEN
      CONTROL SET FOCUS hAdd, %ID_PrevBtn
      CONTROL SEND hAdd, %ID_PrevBtn, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
   ELSEIF showPrev = 0 THEN
      CONTROL SET FOCUS hAdd, %ID_NextBtn
      CONTROL SEND hAdd, %ID_NextBtn, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
   END IF
   showStatus 1
END SUB

FUNCTION getOption(h AS LONG, idMin AS LONG, idMax AS LONG) AS LONG
   'return selected option, beginning with 1 for the first
   LOCAL i, n AS LONG
   FOR i = idMin TO idMax 'get tax option
      CONTROL GET CHECK h, i TO n
      IF n THEN n = i - idMin + 1: FUNCTION = n: EXIT FUNCTION
   NEXT i
END FUNCTION

SUB calcTotal()
   'calculate and show total
   LOCAL s AS STRING, tot, tax AS DOUBLE, n AS LONG
   CONTROL GET TEXT hAdd, %ID_Amount TO s: tot = VAL(s)
   CONTROL GET TEXT hAdd, %ID_Handling TO s: tot = tot + VAL(s)
   CONTROL GET TEXT hAdd, %ID_Shipping TO s: tot = tot + VAL(s)
   n = getOption(hAdd, %ID_AddtaxOpt, %ID_ResaleOpt) - 1
   CONTROL GET TEXT hAdd, %ID_TaxAmt TO s: tax = VAL(s)
   IF n = 1 THEN tax = 0
   tot = tot + tax
   CONTROL SET TEXT hAdd, %ID_Total, FORMAT$(tot, $fmt)
END SUB

SUB editTaxesForm
   LOCAL TXT AS STRING, f AS STRING
   f = "#.####"
   title="State Sales Taxes"
   DIALOG NEW hMain,title$,50,40,170,100,%WS_SYSMENU TO hTax
   CONTROL ADD TEXTBOX, hTax ,%ID_StateTax,"",70,5,40,12
   CONTROL ADD TEXTBOX, hTax ,%ID_CountyTax,"",70,25,40,12
   CONTROL ADD TEXTBOX, hTax ,%ID_LocalTax,"",70,45,40,12
   CONTROL ADD TEXTBOX, hTax ,%ID_DistrictTax,"",70,65,40,12
   CONTROL ADD LABEL, hTax , -1, "State Tax:",3,5,65,12,%SS_RIGHT
   CONTROL ADD LABEL, hTax , -1, "County Tax:",3,25,65,12,%SS_RIGHT
   CONTROL ADD LABEL, hTax , -1, "Local Tax:",3,45,65,12,%SS_RIGHT
   CONTROL ADD LABEL, hTax , -1, "District Tax:",3,65,65,12,%SS_RIGHT
   TXT = FORMAT$(stateTax, f) : CONTROL SET TEXT hTax,%ID_StateTax, TXT
   TXT = FORMAT$(countyTax, f) : CONTROL SET TEXT hTax,%ID_CountyTax, TXT
   TXT = FORMAT$(localTax, f) : CONTROL SET TEXT hTax,%ID_LocalTax, TXT
   TXT = FORMAT$(districtTax, f) : CONTROL SET TEXT hTax,%ID_DistrictTax, TXT
   CONTROL ADD BUTTON, hTax, %ID_OK, "&Ok", 120, 25, 40, 30
   DIALOG SHOW MODAL hTax CALL editTaxesProc
END SUB

CALLBACK FUNCTION editTaxesProc()
   LOCAL TXT AS STRING
   SELECT CASE CBMSG
   CASE %WM_COMMAND
      IF CBCTLMSG = %BN_CLICKED THEN
         IF CBCTL = %ID_OK THEN
            CONTROL GET TEXT hTax,%ID_StateTax TO TXT: stateTax = VAL(TXT)
            CONTROL GET TEXT hTax,%ID_CountyTax TO TXT: countyTax = VAL(TXT)
            CONTROL GET TEXT hTax,%ID_LocalTax TO TXT: localTax = VAL(TXT)
            CONTROL GET TEXT hTax,%ID_DistrictTax TO TXT: districtTax = VAL(TXT)
            taxRate = stateTax + countyTax + localTax + districtTax
            iniFileChanged = 1
            DIALOG END hTax
          END IF
      END IF
   END SELECT
END FUNCTION

SUB taxReport()
   LOCAL i AS INTEGER, j AS INTEGER, z AS LONG, TXT AS STRING
   LOCAL zSales, zSalesTot, zBought, zPersonal, zResale, zTot, zCollected AS LONG
   LOCAL zServices, zIncome, zEarnings, zExpenses, zMiles AS LONG
   showZero = 1
   FOR j = 1 TO numShown
       i = recordNo(j)
       z=trans(i).date
       IF z < startDate OR z > endDate THEN ITERATE FOR
       z = trans(i).amount
       IF trans(i).typeX = %Service THEN
          zServices = zServices + z
       ELSEIF trans(i).typeX = %Expense THEN
          TXT = LCASE$(MID$(storDescr(trans(i).descr),2))
          IF TXT = "mileage" THEN
             zMiles = zMiles + z
          ELSE
             zExpenses = zExpenses + z
          END IF
       ELSEIF trans(i).typeX = %Sold THEN
          zSales = zSales + z
          zSalesTot = zSalesTot + trans(i).taxAmt
          zCollected = zCollected + trans(i).taxAmt
          IF trans(i).taxOpt = 3 THEN zResale = zResale + z
       ELSEIF trans(i).typeX = %Bought THEN
          zBought = zBought + z
          'zCollected = zCollected + trans(i).taxAmt
       ELSEIF trans(i).typeX = %Personal THEN
          zPersonal = zPersonal + trans(i).taxAmt
       ELSEIF trans(i).typeX = %Earnings THEN
          zEarnings = zEarnings + z
       END IF
   NEXT j
   zTot = zSales + zPersonal - zResale - zCollected
   zIncome = zServices + zSales + zEarnings - zBought

   reptVal(1) = showVal(zSalesTot)
   reptVal(2) = showVal(zPersonal)
   reptVal(3) = showVal(zSalesTot + zPersonal)
   reptVal(4) = showVal(zResale)
   reptVal(5) = showVal(zCollected)
   reptVal(6) = showVal(zResale + zCollected)
   reptVal(7) = showVal(zTot)
   reptVal(8) = showVal(zTot * taxRate)
   reptVal(9) = showVal(zTot * taxRate)
   reptVal(11) = showVal(zSales)
   reptVal(12) = showVal(zBought)
   reptVal(13) = showVal(zServices)
   reptVal(14) = showVal(zEarnings)
   reptVal(15) = showVal(zIncome)
   reptVal(16) = showVal(zExpenses)
   reptVal(17) = showVal(zMiles)
   reptData(0) = "State and Local Sales Taxes"
   reptData(1) = "Total gross sales (incl tax)"
   reptData(2) = "Personal, subject to use tax"
   reptData(3) = "Total (line 1 + line 2)"
   reptData(4) = "Sales to others for resale"
   reptData(5) = "Sales tax collected"
   reptData(6) = "Total exempt transactions"
   reptData(7) = "Amount subject to tax"
   reptData(8) = "Total sales and use tax"
   reptData(9) = "Total amount due"
   reptData(10) = "Income Taxes"
   reptData(11) = "Products sales"
   reptData(12) = "Products purchases"
   reptData(13) = "Total services"
   reptData(14) = "Total earnings"
   reptData(15) = "Total Income"
   reptData(16) = "Total Expenses"
   reptData(17) = "Total Miles"
   DIALOG NEW hMain, "Tax Report", , , 200, 275, %WS_SYSMENU TO hRept
   CONTROL ADD BUTTON, hRept, %ID_PrnRept, "&Print", 50, 220, 50, 25
   CONTROL ADD BUTTON, hRept, %ID_Close, "&Close", 120, 220, 50, 25
   DIALOG SHOW MODAL hRept CALL taxReportProc
   showZero = 0
END SUB

CALLBACK FUNCTION taxReportProc()
   LOCAL i, j AS INTEGER
   SELECT CASE CBMSG
     CASE %WM_INITDIALOG
        FOR i = 0 TO 17
           SELECT CASE i
              CASE 0: j = 7
              CASE 1: j = 20
              CASE 10: j = 127
              CASE 11: j = 140
              CASE ELSE: j = j + 10
           END SELECT
          CONTROL ADD LABEL, hRept, -1, reptData(i), 3, j, 100, 10, %SS_LEFT
          CONTROL ADD LABEL, hRept, -1, reptVal(i), 130, j, 50, 10, %SS_RIGHT
        NEXT i
     CASE %WM_COMMAND
        IF CBCTLMSG = %BN_CLICKED THEN
           IF CBCTL = %ID_PrnRept THEN
              printReport
           ELSEIF CBCTL=%ID_Close THEN
              DIALOG END CBHNDL, 0
           END IF
        END IF
     END SELECT
END FUNCTION

SUB printReport()
   LOCAL i, hFont0, hFont1, xppi, yppi AS LONG
   LOCAL x, y, x00, y00, x0, x1, x2, xc, yc AS SINGLE
   XPRINT ATTACH CHOOSE
   IF LEN(XPRINT$) = 0 THEN EXIT SUB
   XPRINT GET MARGIN TO x00, y00, x, y
   XPRINT GET PPI TO xppi, yppi
   x0 = 1.00 * xppi - x00
   x1 = 1.50 * xppi - x00
   x2 = 4.00 * xppi - x00
   FONT NEW "MS Sans Serif", 12, 5 TO hFont0  'bold, uline
   FONT NEW "MS Sans Serif", 10 TO hFont1
   XPRINT SET FONT hFont1
   XPRINT CHR SIZE TO xc, yc
   FOR i = 0 TO 17
      IF i = 0 OR i = 10 THEN
         XPRINT SET FONT hFont0
         y = y + 3 * yc
         XPRINT SET POS (x0, y): XPRINT reptData(i)
         y = y + .5 * yc
      ELSE
         XPRINT SET FONT hFont1
         y = y + 1.5 * yc
         XPRINT SET POS (x1, y): XPRINT reptData(i)
         XPRINT SET POS (x2, y): XPRINT reptVal(i)
      END IF
   NEXT i
   XPRINT CLOSE
END SUB

SUB filterTransX()
   LOCAL thisYr AS INTEGER, i AS INTEGER, nStyle AS LONG
   DIM yr(4) AS STRING
   title="Filter Transactions"
   thisYr=VAL(RIGHT$(DATE$,4))
   FOR i=0 TO 4
       yr(i)=STR$(thisYr - 4 + i)
   NEXT i
   DIALOG NEW hMain,title,,,270,130,%WS_SYSMENU,0 TO hFilter
   nStyle = %CBS_DROPDOWN OR %WS_GROUP OR %WS_TABSTOP
   CONTROL ADD COMBOBOX, hFilter, %ID_YearCmbo, yr(), 42, 10, 40, 90, nStyle
   CONTROL ADD LABEL, hFilter, -1, "Year:", 20, 10, 19, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hFilter, %ID_StartTxt, "", 132, 5, 45, 12
   CONTROL ADD TEXTBOX, hFilter, %ID_EndTxt, "", 132, 20, 45, 12
   CONTROL ADD LABEL, hFilter, -1, "Start Date:", 90, 5, 39, 10, %SS_RIGHT
   CONTROL ADD LABEL, hFilter, -1, "End Date:", 90, 20, 39, 10, %SS_RIGHT
   nStyle = %WS_VSCROLL OR %CBS_DISABLENOSCROLL OR %WS_TABSTOP OR %CBS_DROPDOWN OR %CBS_SORT
   CONTROL ADD COMBOBOX, hFilter, %ID_DescrCmbo, , 72, 60, 90, 100, nStyle
   CONTROL ADD COMBOBOX, hFilter, %ID_NamesCmbo, , 72, 80, 90, 100, nStyle
   CONTROL ADD LABEL, hFilter, -1, "Description:", 30, 60, 40, 10, %SS_RIGHT
   CONTROL ADD LABEL, hFilter, -1, "Name:", 30, 80, 40, 10, %SS_RIGHT
   CONTROL ADD BUTTON, hFilter, %ID_Reset, "&Reset", 200, 50, 40, 25, %WS_TABSTOP
   CONTROL ADD BUTTON, hFilter, %IDOK, "&OK", 200, 80, 40, 25, %WS_TABSTOP OR %BS_DEFAULT
   DIALOG SHOW MODAL hFilter CALL filterTransXProc
END SUB

CALLBACK FUNCTION filterTransXProc()
   LOCAL TXT, txt1 AS STRING
   LOCAL d AS WORD
   LOCAL n AS LONG
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG 'set previous filter state
      fillLists(CBHNDL)
      COMBOBOX FIND EXACT CBHNDL, %ID_DescrCmbo, 1, MID$(storDescr(descr), 2) TO n
      COMBOBOX SELECT CBHNDL, %ID_DescrCmbo, n
      COMBOBOX FIND EXACT CBHNDL, %ID_NamesCmbo, 1, MID$(storNames(names), 2) TO n
      COMBOBOX SELECT CBHNDL, %ID_NamesCmbo, n
      TXT = expandDate(startDate): IF startDate = 0 THEN TXT = ""
      CONTROL SET TEXT CBHNDL, %ID_StartTxt, TXT
      TXT = expandDate(endDate): IF endDate = 65535 THEN TXT = ""
      CONTROL SET TEXT CBHNDL, %ID_EndTxt, TXT
  CASE %WM_COMMAND
      IF CBCTLMSG = %BN_CLICKED THEN
         IF CBCTL = %ID_Reset THEN 'clear the filter
            startDate = 0: endDate = 0: descr = 0: names = 0: typeX = 0
            CONTROL SET TEXT CBHNDL, %ID_DescrCmbo, ""
            CONTROL SET TEXT CBHNDL, %ID_NamesCmbo, ""
            CONTROL SET TEXT CBHNDL, %ID_StartTxt, ""
            CONTROL SET TEXT CBHNDL, %ID_EndTxt, ""
         ELSEIF CBCTL = %IDOK THEN 'process the filter
            TAB SELECT hMain, %ID_TabCtrl, 1: hTab = tabHandle(1)
            CONTROL GET TEXT CBHNDL, %ID_StartTxt TO TXT
            IF LEN(TXT) THEN
               TXT = legalDate(TXT)
               IF LEN(TXT) = 0 THEN MSGBOX "Illegal date", %MB_ICONERROR: EXIT FUNCTION
               d = compressDate(TXT): IF d > startDate THEN startDate = d
            ELSE
               startDate = 0
            END IF
            CONTROL GET TEXT CBHNDL, %ID_EndTxt TO TXT
            IF LEN(TXT) THEN
               TXT = legalDate(TXT)
               IF LEN(TXT) = 0 THEN MSGBOX "Illegal date", %MB_ICONERROR: EXIT FUNCTION
               d = compressDate(TXT): IF d < endDate THEN endDate = d
            ELSE
               endDate = 0
            END IF
            CONTROL GET TEXT CBHNDL, %ID_YearCmbo TO TXT
            IF LEN(TXT) THEN
               TXT = TRIM$(TXT)
               startDate = compressDate("01-01-" + TXT)
               endDate = compressDate("12-31-" + TXT)
            END IF
            IF endDate = 0 THEN endDate = 65535

            CONTROL GET TEXT CBHNDL, %ID_DescrCmbo  TO TXT
            descr = 0: names = 0
            IF LEN(TXT) THEN
               COMBOBOX FIND EXACT CBHNDL, %ID_DescrCmbo, 1, TXT TO n
               COMBOBOX GET USER CBHNDL, %ID_DescrCmbo, n TO descr
            END IF
            CONTROL GET TEXT CBHNDL, %ID_NamesCmbo  TO TXT
            IF LEN(TXT) THEN
               COMBOBOX FIND EXACT CBHNDL, %ID_NamesCmbo, 1, TXT TO n
               COMBOBOX GET USER CBHNDL, %ID_NamesCmbo, n TO names
            END IF
            DIALOG END CBHNDL
            highLite = 0: listTransX
         END IF
      END IF
  END SELECT
END FUNCTION

FUNCTION showVal(t AS LONG) AS STRING
   LOCAL TXT AS STRING
   TXT = LTRIM$(STR$(t))
   IF showZero AND t = 0 THEN TXT = "00"
   IF t = 0 THEN EXIT FUNCTION
   IF LEN(TXT) = 2 THEN TXT = "0" + TXT
   FUNCTION = LEFT$(TXT, LEN(TXT)-2) + "." + RIGHT$(TXT, 2)
END FUNCTION

FUNCTION storVal(BYVAL t AS STRING) AS LONG
   LOCAL n AS BYTE
   IF LEN(t) THEN
      IF INSTR(t, ".") = 0 THEN t = t + "."
      t = t + "00": n = INSTR(t, ".")
      FUNCTION = VAL(LEFT$(t, n - 1) + MID$(t, n + 1, 2))
   END IF
END FUNCTION

FUNCTION legalDate(a$) AS STRING
   LOCAL yr AS INTEGER, dateErr AS BYTE
   LOCAL a1 AS STRING, a2 AS STRING, a3 AS STRING
   REPLACE "/" WITH "," IN a$
   REPLACE "-" WITH "," IN a$
   IF PARSECOUNT(a$)<>3 THEN dateErr = 1
   a1 = PARSE$(a$, 1): a1 = RIGHT$("0" + a1, 2)
   a2 = PARSE$(a$, 2): a2 = RIGHT$("0" + a2, 2)
   a3 = PARSE$(a$, 3): IF a3 = "" THEN a3 = RIGHT$(DATE$, 4)
   yr = VAL(a3)
   IF VAL(a1) > 12 THEN dateErr = 1
   IF VAL(a2) > 31 THEN dateErr = 1
   IF yr < 80 THEN
      yr = 2000 + yr
   ELSEIF yr<100 THEN
      yr = 1900 + yr
   END IF
   IF yr < 1980 OR yr > 2108 THEN dateErr = 1
   IF dateErr THEN EXIT FUNCTION
   a3 = LTRIM$(STR$(yr))
   FUNCTION = a1 + "-" + a2 + "-" + a3
END FUNCTION

FUNCTION compressDate(a$) AS WORD
   'saved format of date
   LOCAL mo AS WORD, day AS WORD, yr AS WORD
   mo = VAL(LEFT$(a$,2))
   day = VAL(MID$(a$,4,2))
   yr = VAL(RIGHT$(a$,4)) - 1980
   ROTATE RIGHT yr,7
   ROTATE LEFT mo, 5
   FUNCTION = yr + mo + day
END FUNCTION

FUNCTION expandDate(w AS WORD) AS STRING
   'display format of date
   LOCAL mo, day, yr AS WORD
   LOCAL m, d AS STRING
   day = w AND 31
   mo = w AND 480
   yr = w AND 65024
   ROTATE LEFT yr,7
   ROTATE RIGHT mo,5
   m = RIGHT$("0" + LTRIM$(STR$(mo)), 2)
   d = RIGHT$("0" + LTRIM$(STR$(day)), 2)
   FUNCTION = m + "-" + d + "-" + LTRIM$(STR$(yr + 1980))
END FUNCTION

SUB insertTrans(transX AS transAction)
   'insert newTransDate into sorted trans() array of numTrans elements
   LOCAL insertPos, i, f, f0, f1 AS LONG
   LOCAL newTransDate AS WORD
   newTransDate = transX.date
   insertPos = 0
   IF numTrans = 0 THEN
      insertPos = 1
   ELSEIF numTrans = 1 THEN
      insertPos = 2
      IF newTransDate < trans(1).date THEN insertPos = 1
   ELSE
      f0 = 1: f1 = numTrans
      IF newTransDate < trans(f0).date THEN insertPos = 1
      IF newTransDate > trans(f1).date THEN insertPos = f1 + 1
      IF insertPos = 0 THEN
         DO
            f = (f0 + f1) \ 2
            IF newTransDate < trans(f).date THEN
               f1 = f
            ELSE
               f0 = f
            END IF
         LOOP UNTIL f1 - f0 = 1
         insertPos = f0 + 1
      END IF
   END IF
   FOR i = numTrans TO insertPos STEP -1
      trans(i + 1) = trans(i)
   NEXT i
   INCR numTrans
   index = insertPos
   trans(insertPos) = transX
   listTransX
END SUB

SUB fillLists(h AS LONG)
   LOCAL i, m, n, k AS LONG
   LOCAL s AS STRING
   'define descr combo box list for this transType
   'ensure unique items in the list
   COMBOBOX RESET h, %ID_DescrCmbo
   m = typeX: IF m = 4 OR m = 5 THEN m = 3
   FOR i = 1 TO numDescr
       n = ASC(LEFT$(storDescr(i), 1))
       s = TRIM$(MID$(storDescr(i), 2))
       IF m = n OR m = 0 THEN
          COMBOBOX FIND EXACT h, %ID_DescrCmbo, 1, s TO k
          IF k THEN ITERATE 'omit duplicates
          COMBOBOX ADD h, %ID_DescrCmbo, s
          COMBOBOX FIND EXACT h, %ID_DescrCmbo, 1, s TO k
          COMBOBOX SET USER h, %ID_DescrCmbo, k, i
       END IF
   NEXT i
   'define name combo box list for this transType
   COMBOBOX RESET h, %ID_NamesCmbo
   FOR i = 1 TO numNames
       n = ASC(LEFT$(storNames(i), 1))
       IF m = n OR m = 0 THEN
          s = TRIM$(MID$(storNames(i), 2))
          COMBOBOX FIND EXACT h, %ID_NamesCmbo, 1, s TO k
          IF k THEN ITERATE 'omit duplicates
          COMBOBOX ADD h, %ID_NamesCmbo, s
          COMBOBOX FIND EXACT h, %ID_NamesCmbo, 1, s TO k
          COMBOBOX SET USER h, %ID_NamesCmbo, k, i
       END IF
   NEXT i
   CONTROL SET SIZE h, %ID_NamesCmbo, 90, 100
END SUB

SUB trimLists
   'remove name & descr from lists if deleting them makes them unused
   LOCAL nn,ds AS STRING
   LOCAL result AS LONG
   LOCAL tx AS STRING, used AS INTEGER
   LOCAL i AS INTEGER, d AS BYTE, n, k AS INTEGER
   'k = recordNo(highLite)
   highLite = oColList.hilite
   k = recordNo(oColList.getRecordNo(highLite))
   d = trans(k).descr: n = trans(k).names
   IF d <> addDescr THEN
      used = 0
      ds = MID$(storDescr(d),2)
      FOR i = 1 TO numTrans
         IF i <> k AND trans(i).descr = d THEN used = i: EXIT FOR
      NEXT i
      IF used = 0 AND LEN(ds) THEN 'get rid of it
         tx = "Description [" + ds + "]" + $CRLF +"not used now... OK to delete it?"
         result = MSGBOX(tx, %MB_YESNO + %MB_ICONQUESTION, "Update Descriptions")
         IF result = %IDYES THEN
            DECR numDescr
            FOR i = d TO numDescr
               storDescr(i) = storDescr(i + 1)
            NEXT i
            FOR i = 1 TO numTrans
               IF trans(i).descr > d THEN DECR trans(i).descr
            NEXT i
         END IF
      END IF
   END IF
   IF n <> addNameX THEN
      used = 0
      nn = MID$(storNames(n),2)
      FOR i = 1 TO numTrans
         'IF i <> recordNo(highLite) AND trans(i).names = n THEN used = i: EXIT FOR
         IF i <> recordNo(oColList.getRecordNo(highLite)) AND trans(i).names = n THEN used = i: EXIT FOR
      NEXT i
      IF used = 0 AND LEN(nn) THEN 'get rid of it
         tx = "Name [" + nn + "]" + $CRLF +"not used now... OK to delete it?"
         result = MSGBOX(tx, %MB_YESNO + %MB_ICONQUESTION, "Update names")
         IF result = %IDYES THEN
            DECR numNames
            FOR i = n TO numNames
               storNames(i) = storNames(i + 1)
            NEXT i
            FOR i = 1 TO numTrans
               IF trans(i).names > n THEN DECR trans(i).names
            NEXT i
         END IF
      END IF
   END IF
END SUB

SUB delTransX
   LOCAL i, n AS LONG
   trimLists
   DECR numTrans: DECR numShown
   'FOR i = recordNo(highLite) TO numTrans
   n = recordNo(oColList.getRecordNo(highLite))
   FOR i = n TO numTrans
      trans(i) = trans(i + 1)
   NEXT i
   IF highLite > numShown - 24 THEN DECR highLite
   highLite = MIN(highLite, numShown): fileChanged = 1
END SUB

SUB editList(idList AS LONG)
   'process names/descr list
   LOCAL nStyle AS LONG
   DIALOG NEW 0, "Process Names List", , , 170, 260, %WS_SYSMENU OR %WS_MINIMIZEBOX TO hList
   nStyle = %WS_TABSTOP OR %WS_VSCROLL OR %LBS_SORT
   CONTROL ADD LISTBOX, hList, %ID_Listbox, , 10, 10, 140, 100, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hList, %ID_Editbox, "", 10, 110, 140, 12, %ES_LEFT
   CONTROL ADD OPTION, hList, %ID_ServOpt, "Services", 20, 135, 60, 12
   CONTROL ADD OPTION, hList, %ID_EarnOpt, "Earnings", 20, 150, 60, 12
   CONTROL ADD OPTION, hList, %ID_ProdOpt, "Products", 20, 165, 60, 12
   CONTROL ADD OPTION, hList, %ID_ExpsOpt, "Expenses", 20, 180, 60, 12
   CONTROL ADD OPTION, hList, %ID_UnusedOpt, "Unused", 20, 195, 60, 12
   CONTROL ADD BUTTON, hList, %ID_Add, "Add", 100, 135, 50, 20
   CONTROL ADD BUTTON, hList, %ID_Change, "Change", 100, 160, 50, 20
   CONTROL ADD BUTTON, hList, %ID_Delete, "Delete ", 100, 185, 50, 20
   CONTROL ADD BUTTON, hList, %ID_Reset, "Reset", 100, 210, 50, 20
   DIALOG SET USER hList, 1, idList
   DIALOG SHOW MODAL hList CALL editListProc
END SUB

CALLBACK FUNCTION editListProc()
   LOCAL i, j, k, n, nList AS LONG
   LOCAL s, ti, z AS STRING
   LOCAL temp() AS LONG
   STATIC idList, numList, optX, nStor, unused AS LONG
   STATIC tx AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         DIALOG GET USER CBHNDL, 1 TO idList
         IF idList THEN ti = "Descriptions" ELSE ti = "Names"
         DIALOG SET TEXT CBHNDL, "List of " + ti
         CONTROL SET OPTION CB.HNDL, %ID_ServOpt, %ID_ServOpt, %ID_UnusedOpt
         optX = 1: numList = fillListbox(idList, optX)
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %ID_ServOpt TO %ID_ExpsOpt
               n = CB.CTL - %ID_AllOpt + 1: optX = VAL(MID$(sPage, n, 1))
               numList = fillListbox(idList, optX): unused = 0: tx = ""
               FOR n = %ID_Editbox TO %ID_Delete: CONTROL ENABLE CB.HNDL, n: NEXT n
               CONTROL SET TEXT CB.HNDL, %ID_Editbox, ""
               CONTROL SET TEXT CB.HNDL, %ID_Reset, "Reset"
            CASE %ID_UnusedOpt
               numList = fillUnused(idList): unused = 1: tx = ""
               FOR n = %ID_Editbox TO %ID_CHANGE: CONTROL DISABLE CB.HNDL, n: NEXT n
               CONTROL SET TEXT CB.HNDL, %ID_Reset, "Delete All"
            CASE %ID_Listbox
               LISTBOX GET SELECT CB.HNDL, %ID_Listbox TO n
               LISTBOX GET USER CB.HNDL, %ID_Listbox, n TO k: nStor = k
               IF unused AND k > 0 THEN
                  s = "Service, Expense, Product, , , Earning"
                  IF idList THEN
                     n = ASC(LEFT$(storDescr(k), 1))
                  ELSE
                     n = ASC(LEFT$(storNames(k), 1))
                  END IF
                  s = "Type of transaction: " + PARSE$(s, n)
                  CONTROL SET TEXT CB.HNDL, %ID_Editbox, s
               END IF
               IF CB.CTLMSG = %LBN_DBLCLK THEN
                  DIALOG POST CB.HNDL, %WM_COMMAND, %ID_Change, 0
               END IF
            CASE %ID_Add
               CONTROL GET TEXT CB.HNDL, %ID_Editbox TO s
               LISTBOX FIND EXACT CB.HNDL, %ID_Listbox, 1, s TO n
               IF n = 0 THEN 'new item
                  IF idList AND LEN(s) THEN
                     INCR numDescr: storDescr(numDescr) = CHR$(optX) + s
                  ELSEIF LEN(s) THEN
                     INCR numNames: storNames(numNames) = CHR$(optX) + s
                  END IF
                  CONTROL SET TEXT CB.HNDL, %ID_Editbox, ""
                  numList = fillListbox(idList, optX): fileChanged = 1
                  LISTBOX FIND EXACT CB.HNDL, %ID_Listbox, 1, s TO n
                  LISTBOX SELECT CB.HNDL, %ID_Listbox, n
               END IF
            CASE %ID_Change
               CONTROL DISABLE CB.HNDL, %ID_Add
               CONTROL DISABLE CB.HNDL, %ID_Delete
               LISTBOX GET SELECT CB.HNDL, %ID_Listbox TO n
               IF n = 0 THEN EXIT FUNCTION
               CONTROL GET TEXT CB.HNDL, %ID_Editbox TO s
               IF LEN(s) = 0 THEN 'put selected item in editbox
                  LISTBOX GET SELECT CB.HNDL, %ID_Listbox TO n
                  LISTBOX GET USER CB.HNDL, %ID_Listbox, n TO k: nStor = k
                  IF idList THEN tx = MID$(storDescr(k), 2) ELSE tx = MID$(storNames(k), 2)
                  CONTROL SET TEXT CB.HNDL, %ID_Editbox, tx
               ELSEIF s <> tx THEN
                  LISTBOX FIND EXACT CB.HNDL, %ID_Listbox, 1, s TO n
                  IF n THEN 'duplicate in list
                     IF idList THEN z = "description" ELSE z = "name"
                     z = "This " + z + " is already used... continue anyway?"
                     ti = UCASE$(LEFT$(z, 1)) + MID$(z, 2) + "s"
                     j = MSGBOX(z, %MB_ICONWARNING OR %MB_YESNO, "Combine " + ti)
                     IF j = %IDNO THEN
                        DIALOG SEND CB.HNDL, %WM_COMMAND, %ID_Reset, 0: EXIT FUNCTION
                     END IF
                     LISTBOX GET USER CB.HNDL, %ID_Listbox, n TO k
                     FOR i = 1 TO numTrans
                        IF idList THEN
                           IF trans(i).descr = k THEN trans(i).descr = nStor
                        ELSE
                           IF trans(i).names = k THEN trans(i).names = nStor
                        END IF
                     NEXT i
                     deleteListItem idList, k
                  END IF
                  IF idList THEN
                     storDescr(nStor) = CHR$(optX) + s
                  ELSE
                     storNames(nStor) = CHR$(optX) + s
                  END IF
                  CONTROL SET TEXT CB.HNDL, %ID_Editbox, "": tx = ""
                  numList = fillListbox(idList, optX): fileChanged = 1
                  LISTBOX FIND EXACT CB.HNDL, %ID_Listbox, 1, s TO n
                  LISTBOX SELECT CB.HNDL, %ID_Listbox, n
                  CONTROL ENABLE CB.HNDL, %ID_Add
                  CONTROL ENABLE CB.HNDL, %ID_Delete
               END IF
            CASE %ID_Delete
               LISTBOX GET SELECT CB.HNDL, %ID_Listbox TO n: nList = n
               IF n = 0 THEN EXIT FUNCTION
               LISTBOX GET USER CB.HNDL, %ID_Listbox, n TO k: nStor = k
               FOR i = 1 TO numTrans
                  IF idList THEN n = trans(i).descr ELSE n = trans(i).names
                  IF n = nStor THEN
                     IF idList THEN s = "description" ELSE s = "name"
                     s = "Cannot delete... this " + s + " is in use"
                     MSGBOX s, %MB_ICONERROR, "Delete Listbox Item"
                     EXIT FUNCTION
                  END IF
               NEXT i
               deleteListItem idList, nStor: fileChanged = 1
               IF unused THEN
                  numList = fillUnused(idList)
               ELSE
                  numList = fillListbox(idList, optX)
               END IF
               LISTBOX GET COUNT CB.HNDL, %ID_Listbox TO n
               LISTBOX SELECT CB.HNDL, %ID_Listbox, MIN(nList, n)
            CASE %ID_Reset
               IF unused THEN 'delete all unused items
                  REDIM temp(1 TO numList)
                  k = numList
                  FOR i = 1 TO k
                     LISTBOX GET USER CB.HNDL, %ID_Listbox, i TO temp(i)
                  NEXT i
                  ARRAY SORT temp(), DESCEND
                  FOR i = 1 TO numList
                     deleteListItem idList, temp(i)
                  NEXT i
                  numList = fillUnused(idList): fileChanged = 1
               ELSE
                  FOR n = %ID_Editbox TO %ID_Delete: CONTROL ENABLE CB.HNDL, n: NEXT n
                  CONTROL SET TEXT CB.HNDL, %ID_Editbox, ""
                  CONTROL SET TEXT CB.HNDL, %ID_Reset, "Reset"
                  unused = 0: tx = ""
               END IF
         END SELECT
      CASE %WM_SYSCOMMAND
      CASE %WM_DESTROY
   END SELECT
END FUNCTION

FUNCTION fillListbox(idList AS LONG, optX AS LONG) AS LONG
   'fill list and return number of items
   LOCAL i, k, n, numList AS LONG
   LOCAL ch, s AS STRING
   CONTROL SEND hList, %ID_Listbox, %WM_SETREDRAW, 0, 0
   IF idList THEN n = numDescr ELSE n = numNames
   LISTBOX RESET hList, %ID_Listbox
   FOR i = 1 TO n
      IF idList THEN
         ch = LEFT$(storDescr(i), 1): s = TRIM$(MID$(storDescr(i), 2))
      ELSE
         ch = LEFT$(storNames(i), 1): s = TRIM$(MID$(storNames(i), 2))
      END IF
      IF optX = 0 OR optX = ASC(ch) THEN
         LISTBOX ADD hList, %ID_Listbox, s: INCR numList
         LISTBOX FIND EXACT hList, %ID_Listbox, 1, s TO k
         LISTBOX SET USER hList, %ID_Listbox, k, i
      END IF
   NEXT i
   CONTROL SEND hList, %ID_Listbox, %WM_SETREDRAW, 1, 0
   FUNCTION = numList
END FUNCTION

FUNCTION fillUnused(idList AS LONG) AS LONG
   LOCAL i, j, n, numList AS LONG, s AS STRING
   IF idList THEN n = numDescr ELSE n = numNames
   DIM temp(n) AS LONG
   FOR i = 1 TO numTrans
      IF idList THEN j = trans(i).descr ELSE j = trans(i).names
      temp(j) = 1
   NEXT i
   CONTROL SEND hList, %ID_Listbox, %WM_SETREDRAW, 0, 0
   LISTBOX RESET hList, %ID_Listbox
   FOR i = 1 TO n
      IF temp(i) = 0 THEN
         IF idList THEN s = MID$(storDescr(i), 2) ELSE s = MID$(storNames(i), 2)
         LISTBOX ADD hList, %ID_Listbox, s: INCR numList
         LISTBOX FIND EXACT hList, %ID_Listbox, 1, s TO j
         LISTBOX SET USER hList, %ID_Listbox, j, i
      END IF
   NEXT i
   CONTROL SEND hList, %ID_Listbox, %WM_SETREDRAW, 1, 0
   FUNCTION = numList
END FUNCTION

SUB deleteListItem(idList AS LONG, nStor AS LONG)
   LOCAL i AS LONG
   IF idList THEN
      ARRAY DELETE storDescr(nStor): DECR numDescr
      FOR i = 1 TO numTrans
         IF trans(i).descr > nStor THEN DECR trans(i).descr
      NEXT i
   ELSE
      ARRAY DELETE storNames(nStor): DECR numNames
      FOR i = 1 TO numTrans
         IF trans(i).names > nStor THEN DECR trans(i).names
      NEXT i
   END IF
END SUB

SUB openThisFile
   LOCAL i, n, hFile, nVer AS LONG
   LOCAL s AS STRING, b AS BYTE
   LOCAL ver AS STRING
   LOCAL temp() AS transAction0
   hFile = FREEFILE
   OPEN thisFile FOR BINARY AS hFile
   ver = SPACE$(17)
   GET hFile,, ver                                    
   n = INSTR(ver, "Version")
   IF n = 0 THEN 'no version data... version earlier than 3
      s = "Previous version of data file will be loaded"
      MSGBOX s, %MB_ICONINFORMATION, "Home Business"
      SEEK #hFile, 1
   ELSE
      ver = SPACE$(n + 8)
      SEEK #hFile, 1: GET hFile,, ver
      nVer = VAL(RIGHT$(ver, 1))
      IF nVer >= 3 AND LEFT$(ver, 7) <> "HomeBus" THEN
         MSGBOX "Not a HomeBus file type", %MB_ICONERROR, "File Error": EXIT SUB
      END IF
   END IF
   GET hFile,, numTrans
   GET hFile,, numDescr
   GET hFile,, numNames
   IF nVer < 3 THEN DIM temp(numTrans)
   FOR i = 1 TO numTrans
      IF nVer = 3 THEN GET hFile,, trans(i)
      IF nVer < 3 THEN GET hFile,, temp(i)
   NEXT i
   FOR i = 1 TO numDescr
      GET hFile,, b
      GET$ hFile, b, storDescr(i)
   NEXT i
   FOR i = 1 TO numNames
      GET hFile,, b
      GET$ hFile, b, storNames(i)
   NEXT i
   CLOSE hFile: fileChanged = 0
   'update data
   IF nVer < 3 THEN
      FOR i = 1 TO numTrans
         trans(i).date     = temp(i).date
         trans(i).typeX    = temp(i).typeX
         trans(i).descr    = temp(i).descr
         trans(i).names    = temp(i).names
         trans(i).amount   = temp(i).amount
         trans(i).handling = temp(i).handling
         trans(i).shipping = temp(i).shipping
         trans(i).taxAmt   = ABS(temp(i).tax)
         trans(i).taxRate  = taxRate
         trans(i).archive  = 0
         IF temp(i).tax < 0 THEN trans(i).taxOpt = 3
      NEXT i
   END IF
   iniFileChanged = 0
END SUB

SUB saveThisFile()
   LOCAL i, hFile AS LONG, b AS BYTE
   LOCAL ver AS STRING * 17
   IF LEN(thisFile) = 0 THEN saveAsFile
   ver = "HomeBus Version 3"
   hFile = FREEFILE
   OPEN thisFile FOR BINARY AS hFile
   PUT hFile,, ver
   PUT hFile,, numTrans
   PUT hFile,, numDescr
   PUT hFile,, numNames
   FOR i = 1 TO numTrans
      PUT hFile,, trans(i)
   NEXT i
   FOR i = 1 TO numDescr
      b = LEN(storDescr(i))
      PUT hFile,, b
      PUT$ hFile, storDescr(i)
   NEXT i
   FOR i = 1 TO numNames
      b = LEN(storNames(i))
      PUT hFile,, b
      PUT$ hFile, storNames(i)
   NEXT i
   CLOSE hFile: fileChanged = 0
   iniFileChanged = 1
END SUB

SUB saveAsFile()
   LOCAL flags AS LONG
   LOCAL f, ti, folder, filter AS STRING
   ti = "Save File": folder = dataFolder  'CURDIR$
   flags = %OFN_OVERWRITEPROMPT OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
   filter = CHR$("Business", 0, "*.bus", 0, "All Files", 0, "*.*", 0)
   DISPLAY SAVEFILE hMain,,, ti, folder, filter, "", "bus", flags TO f
   IF LEN(f) THEN thisFile = f: saveThisFile
END SUB

SUB archiveFile()
   LOCAL i, k, n, w, flags, hFile AS LONG, b AS BYTE
   LOCAL numArchive, numDescrSave, numNamesSave AS WORD
   LOCAL s, ti, folder, filter, f, ver AS STRING
   LOCAL saveDescr(), saveNames() AS STRING

   'specify ending archive date
   s = myInput("Ending year (or date): ", "Archive date")
   IF LEN(s) = 0 THEN EXIT SUB
   n = PARSECOUNT(s, ANY "-/")
   IF n = 1 THEN s = "12-31-" + s
   IF n = 2 THEN s = LEFT$(s, 3) + "31-" + MID$(s, 4)
   w = compressDate(legalDate(s)): i = 1
   DO UNTIL trans(i).date > w: INCR i: LOOP
   numArchive = i - 1

   'save the descr and names list data
   numDescrSave = numDescr: numNamesSave = numNames
   DIM saveDescr(numDescr): DIM saveNames(numNames)
   FOR i = 1 TO numDescr: saveDescr(i) = storDescr(i): NEXT i
   FOR i = 1 TO numNames: saveNames(i) = storNames(i): NEXT i

   'determine descr and names used, and save only them
   DIM temp(numDescr) AS LONG: DIM temp1(numNames) AS LONG
   FOR i = 1 TO numArchive
      temp(trans(i).descr) = 1
      temp1(trans(i).names) = 1
   NEXT i
   k = numDescr
   FOR i = 1 TO k
      IF temp(i) = 0 THEN deleteListItem 1, i
   NEXT i
   k = numNames
   FOR i = 1 TO k
      IF temp1(i) = 0 THEN deleteListItem 0, i
   NEXT i

   'select archive file
   ti = "Archive File": folder = CURDIR$
   flags = %OFN_OVERWRITEPROMPT OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
   filter = CHR$("Business", 0, "*.bus", 0, "All Files", 0, "*.*", 0)
   DISPLAY SAVEFILE hMain,,, ti, folder, filter, "", "bus", flags TO f

   'archive the file
   IF LEN(f) THEN
      ver = "HomeBus Version 3"
      hFile = FREEFILE
      OPEN f FOR BINARY AS hFile
      PUT hFile,, ver
      PUT hFile,, numArchive
      PUT hFile,, numDescr
      PUT hFile,, numNames
      FOR i = 1 TO numArchive
         PUT hFile,, trans(i)
      NEXT i
      FOR i = 1 TO numDescr
         b = LEN(storDescr(i))
         PUT hFile,, b
         PUT$ hFile, storDescr(i)
      NEXT i
      FOR i = 1 TO numNames
         b = LEN(storNames(i))
         PUT hFile,, b
         PUT$ hFile, storNames(i)
      NEXT i
      CLOSE hFile
   END IF

   'retrieve original descr and names list data
   numDescr = numDescrSave: numNames = numNamesSave
   FOR i = 1 TO numDescr: storDescr(i) = saveDescr(i): NEXT i
   FOR i = 1 TO numNames: storNames(i) = saveNames(i): NEXT i

   'remove archived transactions
   numTrans = numTrans - numArchive
   FOR i = 1 TO numTrans
      trans(i) = trans(numArchive + i)
   NEXT i
   listTransX
END SUB

SUB printThisFile()
   LOCAL hFont, xppi, yppi, newPage, maxLines, lineNo AS LONG
   LOCAL i, j, n1, n2, n3 AS LONG, d AS WORD
   LOCAL x0, x1, x2, x3, x4, x5, x6, x7 AS SINGLE
   LOCAL x00, y00, x, y, wi, ht AS SINGLE
   LOCAL typeTxt, descrTxt, nameTxt, sAmt AS STRING
   LOCAL shipHndl AS STRING, salesTax AS STRING, total AS STRING
   XPRINT ATTACH CHOOSE
   IF LEN(XPRINT$) = 0 THEN EXIT SUB
   FONT NEW "MS Sans Serif", 9 TO hFont
   XPRINT SET FONT hFont
   XPRINT GET PPI TO xppi, yppi
   XPRINT GET LINES TO maxLines
   XPRINT GET MARGIN TO x00, y00, x, y
   maxLines = maxLines - 4
   x0 = 0.75 * xppi - x00  'loc to start print
   x1 = 1.50 * xppi - x00
   x2 = 2.10 * xppi - x00
   x3 = 3.40 * xppi - x00
   x4 = 5.60 * xppi - x00
   x5 = 6.30 * xppi - x00
   x6 = 7.00 * xppi - x00
   x7 = 7.80 * xppi - x00
   newPage = 1
   FOR j = 1 TO numShown
      i = recordNo(oColList.getRecordNo(j))
      IF newPage THEN
         y = 0.50 * yppi - y00
         XPRINT SET POS (x0, y): XPRINT "Date"
         XPRINT SET POS (x1, y): XPRINT "Type"
         XPRINT SET POS (x2, y): XPRINT "Descr"
         XPRINT SET POS (x3, y): XPRINT "Name"
         XPRINT TEXT SIZE "Amount   " TO wi, ht: XPRINT SET POS (x4 - wi, y): XPRINT "Amount"
         XPRINT TEXT SIZE "Ship/Hndl" TO wi, ht: XPRINT SET POS (x5 - wi, y): XPRINT "Ship/Hndl"
         XPRINT TEXT SIZE "Tax  "     TO wi, ht: XPRINT SET POS (x6 - wi, y): XPRINT "Tax"
         XPRINT TEXT SIZE "Total  "   TO wi, ht: XPRINT SET POS (x7 - wi, y): XPRINT "Total"
         XPRINT: newPage = 0: lineNo = 2
      END IF
      XPRINT GET POS TO x, y 'get current value of y
      d = trans(i).date
      n1 = trans(i).typeX: typeTxt = transType(n1)
      n2 = trans(i).descr: descrTxt = MID$(storDescr(n2),2)
      n3 = trans(i).names: nameTxt = MID$(storNames(n3),2)
      sAmt = showVal(trans(i).amount)
      shipHndl = showVal(trans(i).shipping + trans(i).handling)
      salesTax = showVal(trans(i).taxAmt)
      total = showVal(trans(i).amount + trans(i).shipping + trans(i).handling + trans(i).taxAmt)
      XPRINT SET POS (x0, y): XPRINT expandDate(d);
      XPRINT SET POS (x1, y): XPRINT typeTxt;
      XPRINT SET POS (x2, y): XPRINT descrTxt;
      XPRINT SET POS (x3, y): XPRINT nameTxt;
      XPRINT TEXT SIZE sAmt     TO wi, ht: XPRINT SET POS (x4 - wi, y): XPRINT sAmt;
      XPRINT TEXT SIZE shipHndl TO wi, ht: XPRINT SET POS (x5 - wi, y): XPRINT shipHndl;
      XPRINT TEXT SIZE salesTax TO wi, ht: XPRINT SET POS (x6 - wi, y): XPRINT salesTax;
      XPRINT TEXT SIZE total    TO wi, ht: XPRINT SET POS (x7 - wi, y): XPRINT total
      INCR lineNo: IF lineNo > maxLines THEN newPage = 1: XPRINT FORMFEED
   NEXT j
   XPRINT CLOSE
END SUB

FUNCTION myInput(OPT BYVAL prompt AS STRING, BYVAL ti AS STRING) AS STRING
   LOCAL hInput AS LONG, s AS STRING, ps AS STRING PTR
   DIALOG NEW 0, ti, , , 130, 85, %WS_SYSMENU TO hInput
   CONTROL ADD LABEL, hInput, -1, prompt, 5, 5, 80, 12
   CONTROL ADD TEXTBOX, hInput, 9900, "", 10, 20, 100, 12
   CONTROL ADD BUTTON, hInput, %IDOK, "Ok", 60, 40, 50, 20
   ps = STRPTR(s): DIALOG SET USER hInput, 1, ps
   DIALOG SHOW MODAL hInput, CALL myInputProc
   FUNCTION = @ps
END FUNCTION

CALLBACK FUNCTION myInputProc()
   LOCAL ps AS STRING PTR
   SELECT CASE CB.MSG
   CASE %WM_INITDIALOG
      CONTROL SET FOCUS CB.HNDL, 9900
   CASE %WM_COMMAND
      IF CB.CTL = %IDOK OR CB.CTL = %IDCANCEL THEN
         DIALOG GET USER CBHNDL, 1 TO ps
         IF CB.CTL = %IDOK THEN CONTROL GET TEXT CB.HNDL, 9900 TO @ps
         DIALOG END CB.HNDL
      END IF
   END SELECT
END FUNCTION

SUB createFolder(folder AS STRING)
   LOCAL i, n AS LONG
   LOCAL f, s AS STRING
   n = PARSECOUNT(folder, "\")
   FOR i = 1 TO n
      f = PARSE$(folder, "\", i)
      IF LEN(f) THEN
         s = s + f + "\"
         IF ISFOLDER(s) = 0 THEN MKDIR s
      END IF
   NEXT i
END SUB

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

'-----------------------------------------------------------------------
'Show About
'-----------------------------------------------------------------------
SUB showAbout
   LOCAL hAbout AS LONG, s AS STRING
   DIALOG NEW hMain,"About Home Business Tracker",,, 220, 160, %WS_SYSMENU TO hAbout
   CONTROL ADD LABEL, hAbout, 9901, "Home Business Tracker", 50, 10, 150, 20
   CONTROL ADD LABEL, hAbout, 9902, " for Windows", 120, 28, 70, 10
   s = "Version " + $verNo + " - Free distribution" + $CRLF
   s = s + "by Charles G. Dietz" + $CRLF + $CRLF
   CONTROL ADD LABEL, hAbout, 9903, s, 50, 40, 180, 30
   s = "chasdietz@verizon.net"
   CONTROL ADD LABEL, hAbout, 9904, s, 60, 80, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   s = "http://www.cgdsoftware.com"
   CONTROL ADD LABEL, hAbout, 9905, s, 60, 95, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   CONTROL ADD IMAGE, hAbout, -1, "myBus", 10, 10, 30, 30
   DIALOG SHOW MODAL hAbout, CALL showAboutProc
END SUB

CALLBACK FUNCTION showAboutProc()
   LOCAL hFont AS LONG
   LOCAL url, email AS ASCIIZ*64
   SELECT CASE CBMSG
   CASE %WM_PAINT
      hFont = makeFont("MS Sans Serif", 14)
      CONTROL SET COLOR CBHNDL, 9901, %RED, -1
      CONTROL SEND CBHNDL, 9901, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10, "i")
      CONTROL SEND CBHNDL, 9902, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10)
      CONTROL SEND CBHNDL, 9903, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10, "u")
      CONTROL SET COLOR CBHNDL, 9904, %BLUE, -1
      CONTROL SEND CBHNDL, 9904, %WM_SETFONT, hFont, 1
      DeleteObject hFont
      hFont = makeFont("MS Sans Serif", 10, "u")
      CONTROL SET COLOR CBHNDL, 9905, %BLUE, -1
      CONTROL SEND CBHNDL, 9905, %WM_SETFONT, hFont, 1
      DeleteObject hFont
   CASE %WM_SETCURSOR  'Change cursor to hand when hovering over label
      IF GetDlgCtrlId(CBWPARAM) >= 9904 THEN
         SetCursor LoadCursor(GetModuleHandle(""), "HAND")
         SetWindowLong CBHNDL, %DWL_MSGRESULT, 1: FUNCTION = 1
      END IF
   CASE %WM_COMMAND
      IF CBCTL = %IDOK OR CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL
      ELSEIF CBCTL = 9904 THEN
         MOUSEPTR 11
         email = "chasdietz@verizon.net"
         ShellExecute(0, "open", "mailto:" + email + "?", "", "", %SW_SHOW)
      ELSEIF CBCTL = 9905 THEN
         MOUSEPTR 11
         url = "http://www.cgdsoftware.com"
         ShellExecute(BYVAL %NULL, "open", url, BYVAL %NULL, BYVAL %NULL,%SW_SHOWMAXIMIZED)
      END IF
   END SELECT
END FUNCTION
